/*
** Animation_transformation.h
** 
** Made by damien
** Login   <damien@ortie>
** 
** Started on  Sun Jan 27 10:29:51 2008 damien
** Last update Sun Jan 27 10:29:51 2008 damien
*/

#ifndef   	ANIMATION_TRANSFORMATION_H_
# define   	ANIMATION_TRANSFORMATION_H_


#include <stdlib.h>
#include <iostream>
#include <cmath>
#include <string>
#include <errno.h>
#include <stdio.h>

#include <vector>
using namespace std;

#include <Matrix.h>

class Animation_transformation
{
 public:

  Animation_transformation();
  ~Animation_transformation();


  int set_size_time(int size);
  int set_size_angle(int size);

  int set_time(int k_time,double val);
  int set_angle(int k_time,int k_axis,double val);
  int set_translation(int k_trime,double tx,double ty,double tz);
  int set_anim_matrix(int k_time,int k_dim,double value);

  double get_angle(int k_time,int k_axis);

  Matrix get_rotation(double t);
  Matrix get_translation(double t);
  Matrix get_matrix(double t);

  int get_size();
  double get_time(int k_index);

  Animation_transformation& operator=(const Animation_transformation&);

 private:

  int bone_number;
  std::vector <double>angle_x;
  std::vector <double>angle_y;
  std::vector <double>angle_z;
  std::vector <double>translation;
  std::vector <double>time;
  std::vector <double>anim_matrix;

};


#endif 	    /* !ANIMATION_TRANSFORMATION_H_ */
