/*
** File_parser.h
** 
** Made by damien
** Login   <damien@ortie>
** 
** Started on  Fri Jan 25 19:23:33 2008 damien
** Last update Fri Jan 25 19:23:33 2008 damien
*/

#ifndef   	FILE_PARSER_H_
# define   	FILE_PARSER_H_

#include <stdlib.h>
#include <iostream>
#include <cmath>
#include <string>
#include <errno.h>
#include <stdio.h>
using namespace std;


#include <Mesh_object.h>
#include <Curve_3D.h>
#include <Skinned.h>
#include <Skeleton.h>

#include <tinyXml/tinyxml.h>
#include <tinyXml/tinystr.h>


class File_parser
{
 public:

  File_parser();
  ~File_parser();


  int load_collada_skeleton(const char* filename,const char* skeleton_name,Skeleton *skeleton) const;
  int load_collada_animation(const char* filename,Skeleton *skeleton) const;
  int load_collada_skining_attribute(const char* filename, Skinned *skinned) const;

  int save_skeleton_sk(const char* filename,Skeleton &skeleton) const;
  int save_collada_skeleton(const char *filename,Skeleton &skeleton) const;
  int load_old_sk_skeleton(const char *filename,Skeleton *skeleton) const;//old


 private:

  int reccursive_skeleton_collada_reading_node(TiXmlHandle &current_node,Joint *current) const;
  int reccursive_collada_skeleton_writing(Joint *current,FILE *fid) const;
  
};


#endif 	    /* !FILE_PARSER_H_ */
