/*
**    Mesh Converter
**    Copyright (C) 2008  Damien Rohmer
**
**    This program is free software: you can redistribute it and/or modify
**    it under the terms of the GNU General Public License as published by
**    the Free Software Foundation, either version 3 of the License, or
**    (at your option) any later version.
**
**   This program is distributed in the hope that it will be useful,
**    but WITHOUT ANY WARRANTY; without even the implied warranty of
**    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
**    GNU General Public License for more details.
**
**    You should have received a copy of the GNU General Public License
**    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/


/*
** container_int_vector.h
** 
** Made by damien
** Login   <damien@ortie>
** 
** Started on  Mon Sep  1 12:13:13 2008 damien
** Last update Mon Sep  1 12:13:13 2008 damien
*/

#ifndef   	CONTAINER_INT_VECTOR_H_
# define   	CONTAINER_INT_VECTOR_H_

#include <stdlib.h>
#include <iostream>
#include <cmath>
#include <string>
#include <errno.h>
#include <stdio.h>


#include <vector>
#include <int_vector.h>

/// Container class for int_vector

class container_int_vector
{

public:
  
  //************************************************//
  //************************************************//
  // CONSTRUCTORS
  //************************************************//
  //************************************************//

  /// Classical constructor
  container_int_vector();
  /// Copy constructor
  container_int_vector(const container_int_vector& );
  /// Destructor
  ~container_int_vector();

  
  //************************************************//
  //************************************************//
  // Manipulation
  //************************************************//
  //************************************************//

  /// return the number of int_vector
  int size() const;

  /// add an int_vector
  int add(const int_vector& to_add) ;

  /// set size 0
  int destroy();

  //************************************************//
  //************************************************//
  // Operator
  //************************************************//
  //************************************************//

  //affectation operator
  const container_int_vector& operator=(const container_int_vector&);
  
  /// test equality
  friend bool operator==(const container_int_vector&,const container_int_vector&);
  /// test equality
  friend bool operator!=(const container_int_vector&,const container_int_vector&);

  /// get operator
  const int_vector& operator[](int k_int_vector) const;
        int_vector& operator[](int k_int_vector) ;
  


private:
  
  std::vector <int_vector> int_list;

};



#endif 	    /* !CONTAINER_INT_VECTOR_H_ */

