/*
**    Mesh Converter
**    Copyright (C) 2008  Damien Rohmer
**
**    This program is free software: you can redistribute it and/or modify
**    it under the terms of the GNU General Public License as published by
**    the Free Software Foundation, either version 3 of the License, or
**    (at your option) any later version.
**
**   This program is distributed in the hope that it will be useful,
**    but WITHOUT ANY WARRANTY; without even the implied warranty of
**    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
**    GNU General Public License for more details.
**
**    You should have received a copy of the GNU General Public License
**    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/


/*
** int_vector.h
** 
** Made by damien
** Login   <damien@ortie.inrialpes.fr>
** 
** Started on  Thu Feb  7 20:42:09 2008 damien
** Last update Thu Feb  7 20:42:09 2008 damien
*/

#ifndef   	INT_VECTOR_H_
# define   	INT_VECTOR_H_

#include <stdlib.h>
#include <iostream>
#include <cmath>
#include <string>
#include <errno.h>
#include <stdio.h>

#include <vector>
using namespace std;

class int_vector
{
 public:
  int_vector();
  int_vector(const int_vector&);
  int_vector(const std::vector<int>&);
  ~int_vector();

  int size() const;
  int resize(int _size);

  int &operator[](int k_vertex);
  int operator[](int k_vertex) const;
  int_vector& operator=(const int_vector&);

  int add_unique(int k_index);
  int add(int k_vertex);
  int add(const std::vector <int>& _int_list);

  /// check if the index exist.
  /** If the index already exists, returns its index
      Else return -1*/
  int exists(int index_to_find) const;

  friend bool operator==(const int_vector& cont_1,const int_vector& cont_2);
  friend bool operator!=(const int_vector& cont_1,const int_vector& cont_2);

 private:
  
  std::vector <int> int_list;
};


#endif 	    /* !INT_VECTOR_H_ */
